static    char    sccsid[]="%Z% %M% %I% %E% %U%";
/********************************************************************/
/* <cllex.c>														*/
/*																*/
/*			p̈ύX										*/
/*			񒷃`FbNύX								*/
/********************************************************************/

#include "colmn.h"

#define YEN '\\'
#define WKBUFLEN	BUFLEN*8
#define WKBUFMAX	WKBUFLEN-1

extern CLCOMMON CLcommon;
extern GlobalCt *pGlobTable;
extern int giOptions[];
extern XHASHB *xhp_main_def;

extern condList  CLcList;	/* 񃊃Xg */
extern CLNCB     CLSTCB;	/* ^O̍\͂s߂̗̈ */

static int _parmset();
static int _kugiri();
static int _proc_pragma();
static int _rep_define();
static int _resume_define();
static int _include_define();

static XHASHB *sqp_lex_def=NULL;
static XHASHB *xhp_lex_def=NULL;
static char comstr[24];
static char cM_QUOTE1, cM_QUOTE2;

typedef struct {
	int  pra_opt;	/* 0:rep_def, 1:include */
	char *pra_defkey;
	SSPL_S pra_sspl;
	condList pra_cList;	/* 񃊃Xg */
} tdtPragmaStack;

#define CLISTSTACKMAX	20
static int iListStack=0;
static int iListStack0=0;
static tdtPragmaStack tPragmaStack[CLISTSTACKMAX+1];

#define MAXIFNEST	20
static int ifnest_cnt,ifnest[MAXIFNEST],iftrue[MAXIFNEST];

#define DEF_OPTC_ICASE	'*'
#define DEFICASEMAX	20

/************************************/
/* cl_chk_pos						*/
/************************************/
static int _chk_pos(psspl,pos)
SSPL_S *psspl;
int pos;
{
	int i,len,l,rc,lend;
	char *buf,*p;

	buf = psspl->wd;
	i   = psspl->sp;
	len = psspl->wdmax;

DEBUGOUTL4(LEX_LOG_GROUP+255,"cl_chk_pos enter:pos=%d i=%d len=%d attr[3]=%d",pos,i,len,psspl->attr[3]);

/*	if (buf[len-1] == '\n') len--;	*/
	if (i>=len && psspl->attr[3]) return -1;
	if (i+pos >= len) {
		l = len - i;
		if (l>0 && i>0) {
			memcpy(buf,buf+i,l);
			len = l;
		}
		else len = 0;
		buf[len] = '\0';
		psspl->sp = 0;
		i = psspl->sp + pos;
		p = buf + len;
		while (i>=len && !psspl->attr[3]) {
			if (len>0 && *p=='\n') {
				len--;
				*(--p) = '\n';
			}
			rc = cl_get_str(p);
			if (rc) {
				psspl->attr[3] = 1;		/* File End */
				if (!len) return -1;
			}
			else {
				l = strlen(p);
				len += l;
				p   += l;
			}
			 
		}
		psspl->wdmax = len;

DEBUGOUTL4(LEX_LOG_GROUP+124,"cl_chk_pos ret  :i=%d len=%d attr[3]=%d buf=[%s]",i,len,psspl->attr[3],buf);

	}
	return psspl->sp;
}

static int cl_chk_pos(psspl,pos)
SSPL_S *psspl;
int pos;
{
	int i;

	if ((i=_chk_pos(psspl,pos)) < 0) {
		if (_resume_define(psspl)) i = psspl->sp;
	/*	if (_resume_define(psspl)) return cl_chk_pos(psspl,pos);	*/
		else i = ECL_END_OF_FILE;
	}
	return i;
}

#if 0
static int cl_get_char(buff,psspl)
char *buff;
SSPL_S *psspl;
{
	int i,len,ic,rc;
	unsigned char c;

	i = cl_chk_pos(buff,psspl)
	if (i == EOF) return EOF;
	c = buff[i];
	while (c == '\n') {
		psspl->sp = ++i;
		i = cl_chk_pos(buff,psspl)
		if (i == EOF) return EOF;   /* File End */
		c = buff[i];
	}
	if (iskanji(buff+i)) {
		psspl->attr[0] = c;
		psspl->attr[1] = buff[++i];
		rc = 2;
	}
	else {
		psspl->attr[0] = c;
		rc = 1;
	}
	psspl->sp = i;

	retuen rc;
}
#endif

/************************************/
/* _alloc_cmd_parl					*/
/************************************/
static int _alloc_cmd_parl()
{
	char *p;

	if (!CLcList.cmd.parnum) {
		if (!(CLcList.cmd.parl=(ParList *)cl_const_ct_malloc(CLcList.ConstCt,sizeof(ParList)*MAX_PARL))) {
 			ERROROUT("Malloc CLcList_parl");
			return ECL_MALLOC_ERROR;
		}
		CLcList.cmd.parnum = MAX_PARL;
		memset(CLcList.cmd.parl,0,sizeof(ParList)*CLcList.cmd.parnum);
		CLcList.cmd.parl[1].par = CLcList.fullname;
		CLcList.cmd.parl[1].parlen = 0;
/*
DEBUGOUTL1(LEX_LOG_GROUP+120,"_lex_cmd_init: CLcList.fullname=[%s]",CLcList.fullname);
*/
	}
	return 0;
}

/************************************/
/* cl_lex_snln						*/
/************************************/
char *cl_lex_snln()
{
	static char *fmt="at script=[%s] line=%d";
	static char wrk[128],*p0=NULL;
	char *buf,*name,sname[33];
	int len;

	if (!(buf=CLcList.fullname)) buf = CLcList.fname;
	name = akxt_get_last_name("\\/",buf);
	len = strlen(name) + 30;
	if ((len=akxmemwork(len,&buf,&p0,wrk,sizeof(wrk))) <= 0) {
		buf = wrk;
		strncpy(sname,name,32);
		name = sname;
	}
DEBUGOUTL1(LEX_LOG_GROUP+120,"cl_lex_snln: name=[%s]",name);
	sprintf(buf,fmt,name,CLcList.line);
	return buf;
}

/***************************************************/
/* _parmset (\ cmdInfo ւ̃p[^̐ݒ)  */
/***************************************************/
static int _parmset(pp,len,opt)
char *pp;
int  len,opt;
{
	parmList *lp;
	int rc;

#if 1
	if (CLcList.cmd.prmnum >= CLcList.max_prmnum) {
		if (!(CLcList.cmd.prmp=(parmList **)Realloc(CLcList.cmd.prmp,sizeof(parmList *)*(CLcList.max_prmnum+PM_MAX)))) {
			ERROROUT("Realloc CLcList_prmp");
			return ECL_MALLOC_ERROR;
		}
		CLcList.max_prmnum += PM_MAX;
/*
printf("_parmset: CLcList.max_prmnum=%d\n",CLcList.max_prmnum);
*/
	}
#else
	if( CLcList.cmd.prmnum >= PM_MAX ) {
		ERROROUT3("cllex:param. number>%d at line=%d parm[%s]",PM_MAX,CLcList.line,pp);
		return ECL_LEX;
	}
#endif
	lp = (parmList *)cl_const_ct_malloc(CLcList.ConstCt,sizeof(parmList));
	if (!lp) {
		ERROROUT2("cllex:malloc error.%s parm[%s]",cl_lex_snln(),pp);
	/*	ERROROUT2("cllex:malloc error.at line=%d parm[%s]",CLcList.line,pp);	*/
		return ECL_MALLOC_ERROR;
	}
	memset(lp,0,sizeof(parmList));
	lp->prmlen = len;
	lp->prp = (char *)pp;
/*
printf("_parmset: prmnum=%d len=%d pp=[%s]\n",CLcList.cmd.prmnum,len,pp);
*/
	CLcList.cmd.prmp[CLcList.cmd.prmnum] = lp;
	CLcList.cmd.prmnum++;
	if (opt) {
		if (CLcList.mcat->mc_ipos > 0) {
			rc = akxtmcats(CLcList.mcat," ");
		}
		else rc = 0;
		if (rc >= 0) rc = akxtmcat(CLcList.mcat,pp,len);
		if (rc < 0) {
			ERROROUT2("cllex:malloc error.%s parm[%s]",cl_lex_snln(),pp);
			return ECL_MALLOC_ERROR;
		}
	}
	rc = _alloc_cmd_parl();
	return rc;
}

/************************************/
/* clparmset						*/
/************************************/
int clparmsetopt(wkstr, parmlen, opt)
char *wkstr;
int parmlen,opt;
{
	char *parm;
	int rc;

	parm = cl_const_ct_malloc(CLcList.ConstCt,parmlen+1);
	if (parm) {
		memzcpy(parm,wkstr,parmlen);
		parmlen = strlen(parm);
		rc = _parmset(parm,parmlen,opt);
	}
	else {
		ERROROUT2("cllex:malloc error.%s parm[%s]",cl_lex_snln(),wkstr);
		rc = ECL_MALLOC_ERROR;
	}
	return rc;
}

int clparmset(wkstr, parmlen)
char *wkstr;
int parmlen;
{
	return clparmsetopt(wkstr,parmlen,0);
}

/************************************/
/* clparmset2						*/
/************************************/
int clparmset2()
{
	char *p;
	int len,lenc,rc=0;

	lenc = strlen(comstr);
	len = CLcList.mcat->mc_ipos;
	p = cl_const_ct_malloc(CLcList.ConstCt,len+lenc+2);
	if (p) {
		if (rc=_alloc_cmd_parl()) return rc;
		memzcpy(p,CLcList.mcat->mc_bufp,len);
		CLcList.cmd.parl[0].par = p;
		CLcList.cmd.parl[0].parlen = len;
		CLcList.mcat->mc_ipos = 0;
#if 1	/* SET_CMD_NAME */
		p += len + 1;
		memzcpy(p,comstr,lenc);
/*		p = Strdup(cl_gets_cmd_name(CLcList.cmd.cid));	*/
		CLcList.cmd.parl[2].par = p;
		CLcList.cmd.parl[2].parlen = lenc;
/*
printf("clparmset2: parl[2].par=[%s]\n",p);
*/
#endif
	}
	else {
		ERROROUT2("cllex:malloc error.%s parm[%s]",cl_lex_snln(),CLcList.mcat->mc_bufp);
		rc = ECL_MALLOC_ERROR;
	}
	return rc;
}

/***************************************************/
/* clparmclr (\ cmdInfo ̃p[^̏)@ */
/***************************************************/
int clparmclr()
{
	int i;
/*
	for (i=0;i<CLcList.max_prmnum;i++) {
		CLcList.cmd.prmp[i] = NULL;
	}
*/
	CLcList.cmd.prmnum = 0;
	CLcList.mcat->mc_ipos = 0;
	return 0;
}

/***************************************************/
/* cl_syn_main                                     */
/***************************************************/
int cl_syn_main()
{
	int rc;
	char *pCmdLine;

if (DEBUGOUTCHECK(LEX_LOG_GROUP+120)) {
	if (!cl_get_cmd_line(&CLcList.cmd,&pCmdLine)) DEBUGOUTL1(LEX_LOG_GROUP+120,"lex:[%s]",pCmdLine);
}
	rc = cl_tree_main();	/* ؍\쐬 */
	if (rc) {
	/*
		ERROROUT3("cllex:Create tree error=%d at script=[%s] line=%d",rc,
			CLcList.fname,CLcList.line);
	*/
		ERROROUT2("cllex:Create tree error=%d %s",rc,cl_lex_snln());
		if (!cl_get_cmd_line(&CLcList.cmd,&pCmdLine)) {
			if (!pCmdLine) pCmdLine = "";
			ERROROUT1(" ---> [%s]",pCmdLine);
		}
	}
/*	_lex_cmd_init();	*/
	return rc;
}

/************************************/
/* _to_han_type						*/
/*  flag :  = 0 : pɕϊꂽ	*/
/*			= 1 : Sp̂܂܎g	*/
/************************************/
static int _to_han_type(moji,quote,wrk,type)
char *moji,quote,*wrk;
int  type;
{
	int flag=1;	/*  */
	char c;

	if (!(pGlobTable->options[8] & 0x02)) {
#if 1	/* 2020.5.5 */
		if (akxctohan_type_opt(1,moji,wrk,type,0x10) == 1) {
#else
		if (akxctohan_opt(1,moji,wrk,0x10) == 1) {
#endif
			c = wrk[0];
			wrk[1] = '.';
			if (pGlobTable->options[8] & 0x01) flag = 0;	/* SẲpL𔼊pɕϊ */
			else if (!quote/* || c=='\'' || c=='"'*/) flag = 0;
		}
	}
	return flag;
}

/************************************/
/* _to_han							*/
/************************************/
static int _to_han(moji,quote,wrk)
char *moji,quote,*wrk;
{
	return _to_han_type(moji,quote,wrk,CD_TYPE_SJIS);
}

/************************************/
/* _is_han_type						*/
/************************************/
static char _is_han_type(moji,quote,wrk,type)
char *moji,quote,*wrk;
int  type;
{
	int lenc,c;

#if 1	/* 2020.5.5 */
	if (lenc=akxqismbs(type,moji)) {
#else
	if (lenc=iskanji(moji)) {
#endif
		c = '\0';
#if 1	/* 2020.5.5 */
		if (!_to_han_type(moji,quote,wrk+1,type)) c = wrk[1];
#else
		if (!_to_han(moji,quote,wrk+1)) c = wrk[1];
#endif
	}
	else {
		lenc = 1;
		c = moji[0];
	}
	wrk[0] = lenc;
/*
printf("_is_han: lenc=%d c=%c\n",lenc,c);
*/
	return c;
}

/************************************/
/* _is_han							*/
/************************************/
static char _is_han(moji,quote,wrk)
char *moji,quote,*wrk;
{
	return _is_han_type(moji,quote,wrk,CD_TYPE_SJIS);
}

/************************************/
/* _skip_line						*/
/************************************/
static int _skip_line(buf,psspl)
char *buf;
SSPL_S *psspl;
{
	int len,flg,rc,i;
	char c1;

	len = psspl->wdmax;
	flg = 1;
	while (flg) {
		if ((c1=buf[len-1])=='\n' || c1=='\r') flg = 0;
		rc = cl_get_str(buf);	/* ݍŝĂāA̍sǍ */
		if (rc != 0) {
			if (_resume_define(psspl)) {
				i = psspl->sp;
				return i;
			}
			else return ECL_END_OF_FILE;	/* File End */
		}
		len = strlen(buf);
/*
printf("_skip_line: len=%d buf=[%s]\n",len,buf);
*/
	}
	i = 0;
	psspl->wdmax = len;
	return i;
}

/************************************/
/* _add_LF							*/
/************************************/
static void _add_LF(cont,cont_len)
char *cont;
int cont_len;
{
	char *p,c1;

	p = cont + cont_len;
	if (cont_len > 0) {
		if (!((c1=cont[cont_len-1])=='\n' || c1=='\r')) strcpy(p,"\n");
	}
	else strcpy(p,"\n");
}

/************************************/
/* _get_def_cont					*/
/************************************/
static int _get_def_cont(buf,pos,psspl,cont,cont_max)
char *buf;
int pos;
SSPL_S *psspl;
char *cont;
int cont_max;
{
	int flg,rc,len,i,cont_rem,n,ret,cont_len;
	char c1,*p;
/*
	pos++;
	cont_rem = cont_max - 2;
*/
	cont_rem = cont_max - 1;
	cont_len = 0;
	p = cont;
	len = psspl->wdmax;
/*
 * "KEY (a,...)"̂Ƃ́AȂƂ邽߁AKEY̋󔒕̓XLbvȂB
	i = akxnskipin(buf+pos,len-pos," \t");
	pos += i;
*/
	flg = 1;
	ret = 0;
	while (flg) {
		n = len - pos;
		if ((c1=buf[len-1])=='\n' || c1=='\r') {
			flg = 0;
			n--;
			if (pos+n-1>=0 && buf[pos+n-1]=='\r') n--;
			if (pos+n-1>=0 && buf[pos+n-1]=='\\') {
				flg = 1;
				buf[pos+n-1]='\n';
			}
		}
		i = 0;
		memnzcpy(p,buf+pos+i,n,cont_rem);
/*
printf("_get_def_cont: pos=%d len=%d n=%d i=%d p=[%s]\n",pos,len,n,i,p);
*/
		p += n;
		cont_len += n;
		cont_rem -= n;
		if (flg) {
			rc = cl_get_str(buf);	/* ̍sǍ */
			if (rc != 0) {
#if 0
				return ECL_END_OF_FILE;
#else
				if (!_resume_define(psspl)) break;
#endif
			}
			len = strlen(buf);

DEBUGOUTL2(LEX_LOG_GROUP+122,"_get_def_cont: len=%d buf=[%s]\n",len,buf);

			psspl->wdmax = len;
			pos = 0;
		}
	}
	strcpy(p," ");
/*	_add_LF(cont,cont_len);	*/
	return 0;
}

/************************************/
/* ̃X^bNɂǗ		*/
/************************************/
#define _SP_EXT	64
static int _sp_max=0;
static int *_stack=NULL;
static int _sp=0;

/****************************/
/* _push					*/
/****************************/
static int _push(x)
int x;
{
	if (_sp >= _sp_max) {
		_sp_max += _SP_EXT;
		if (_stack) _stack = (int *)Realloc(_stack,_sp_max*sizeof(int));
		else        _stack = (int *)Malloc(_sp_max*sizeof(int));
		if (!_stack) return -4;
	}
	_stack[_sp++] = x;
	return 0;
}

/****************************/
/* _pop						*/
/****************************/
static int _pop()
{
	if (_sp <= 0) return -5;
	return _stack[--_sp];
}

/****************************/
/* _peek					*/
/****************************/
static int _peek()
{
	if (_sp <= 0) return 0;
	return _stack[_sp-1];
}

/****************************/
/* _chk_act					*/
/****************************/
static int _chk_act(c)
char c;
{
	int i,j,rc;

	if (c < 0) {
		_sp = 0;
		return 0;
	}

	if      (c == '(') j = 1;
	else if (c == '{') j = 2;
	else if (c == '[') j = 3;
	else if (c == ')') j = 4;
	else if (c == '}') j = 5;
	else if (c == ']') j = 6;
	else return -2;

	rc = 0;
	if (j <= 3) rc = _push(j);
	else {
		i = _peek();
		if (i<1 || i>3) rc = -3;
		else if (i == j-3) rc = _pop();
		else rc = -11;
	}
	if (rc > 0) rc = 0;
	return rc;
}

#if 1	/* 2020.5.6 */
/****************************/
/* _is_sjis_hankaku_kana	*/
/****************************/
static int _is_sjis_hankaku_kana(c)
uchar c;
{
	int rc;

	if (c>=161 && c<=223) rc = 1;
	else rc = 0;
	return rc;
}
#endif
/************************************/
/* cl_lex (flk^O)		*/
/************************************/
int cl_lex()
{
	int   kugiri_flg = 0;
	char  buff[BUFLEN*2];
	char  wkstr[BUFLEN*8];
	int	exit_flag=0, line_cont;
	ushort sjis;
	char  comstr[24],wrk[4];
	char  *parm,*p;
	int   len,cut;
	int   rc,rc_def;
	int   i,tree,h,parmlen,cnum,j,flag,lenc,len8,ex_opt,sc_code;
	char  code,info,quote,c,c1;
	unsigned char uc;
	int   new_lex = 0;
	int   moji_const = 0;	/* BEXP $a = '//null/%s';//RgɂȂ */
	SSPL_S sspl;
	int   cm_level=0;	/* ^@^`̃Rg̃lXgx */
	int   kk_level=0;	/* ()̃lXgx */
	int   k2_level=0;	/* {}̃lXgx */
	int   k3_level=0;	/* []̃lXgx */
	int   def_parm;
	ScrPrCT *scrptct;
	int   inter_mode;

	if ( CLcList.fp == NULL ) return(-1);
	CLcList.rbuf = buff;
	rc = cl_get_str(buff);
	if (rc) {
		ERROROUT(FORMAT(40));	/* cllex:XNvgEt@CłB */
		goto FEND2;					/* File End */
	}
	if (!memcmp(buff,"#!",2)) {
		rc = cl_get_str(buff);		/* ݍŝĂāA̍sǍ */
		if (rc != 0) goto FEND2;	/* File End */
	}
	len = strlen(buff);
	def_parm = 0;
	h = 0;
	i = 0;
	info  = 'N';					/* NewLine */
	quote = '\0';
	clparmclr();
	CLSTCB.nestLev1 = NULL;
	CLSTCB.nestLev2 = NULL;
	cl_cmd_init(&CLcList.cmd);		/* ݒ */
	CLcList.mcat->mc_ipos = 0;
	if (CLcList.option & D_SCRPT_NEW_LEX) new_lex = 1;

#if 1
	if (scrptct = cl_search_src_ct()) inter_mode = scrptct->pFlag & D_SCRPT_INTERACTIVE;
	else inter_mode = 0;
#endif

	cM_QUOTE1 = pGlobTable->Quot[0];
	cM_QUOTE2 = pGlobTable->Quot[1];

/*	if (rc=_lex_cmd_init()) return rc;	*/
	if ((rc=_alloc_cmd_parl()) < 0) return rc;
	if (rc=_proc_pragma(NULL,0,0,0)) return rc;

	sc_code = CD_TYPE_SJIS;
	ex_opt = cl_get_option(21,0);
	ex_opt = (ex_opt>>16) & 0xFF;
	if (ex_opt) sc_code = ex_opt;

	_chk_act(-1);
	sspl.wd = buff;
	sspl.wdmax = len;
	sspl.attr[3] = 0;
	while (!exit_flag) {
		if (h > BUFLEN*8) break;
/*
printf("cllex: len=%d h=%d i=%d c=%c\n",len,h,i,buff[i]);
*/
		sspl.sp = i;
		if ((i=cl_chk_pos(&sspl,0)) < 0) goto FEND;		/* File End */
/*
printf("cllex: len=%d h=%d i=%d c=%c\n",len,h,i,buff[i]);
*/
#ifdef CYGWIN_U8	/* 2020.5.5 */
		uc = *(buff+i);
		if (lenc=akxqismbs(sc_code,buff+i)) {
#else
		if (lenc=iskanji(buff+i)) {
#endif
			flag = 1;
			if (h > BUFLEN*8-2) exit_flag = 1;
			else {
				if (!cm_level || (pGlobTable->options[8] & 0x03)==1) {
					flag = _to_han_type(buff+i,quote,wrk,sc_code);
					c = wrk[0];
/*
printf("cllex: lenc=%d flag=%d wrk=%02x %02x\n",lenc,flag,wrk[0] & 0xff,wrk[1] & 0xff);
*/
					if (sc_code == CD_TYPE_SJIS) {
						if (flag) {	/* ͒l̂܂܎g */
							sjis = *(buff+i);
							sjis = sjis<<8 | (uchar)*(buff+i+1);
							len8 = akxc_sj_to_utf8(sjis,wkstr+h,NULL);
/*
printf("cllex:zenkaku flga=%d len8=%d\n",flag,len8);
*/
							h += len8;
						}
						else if (_is_sjis_hankaku_kana(c)) {
							sjis = uc;
							len8 = akxc_sj_to_utf8(sjis,wkstr+h,NULL);
/*
printf("cllex:_hankaku_kana flga=%d len8=%d\n",flag,len8);
*/
							h += len8;
							i += lenc;
							continue;
						}
					}
					else {
						if (flag) {	/* ͒l̂܂܎g */
							memcpy(wkstr+h,buff+i,lenc);
							h += lenc;
						}
					}
				}
				i += lenc;
			}
			if (flag) continue;
		}
#ifdef CYGWIN_U8	/* 2020.5.6 */
		else if (!cm_level && sc_code==CD_TYPE_SJIS && _is_sjis_hankaku_kana(uc=*(buff+i))) {
			sjis = uc;
			len8 = akxc_sj_to_utf8(sjis,wkstr+h,NULL);
/*
printf("cllex:_hankaku_kana len8=%d\n",len8);
*/
			h += len8;
			i++;
			continue;
		}
#endif
		else {
			c = buff[i++];
		}
		len = sspl.wdmax;

DEBUGOUTL3(LEX_LOG_GROUP+255,"cllex:len=%d h=%d i=%d",len,h,i);
DEBUGOUTL3(LEX_LOG_GROUP+255,"cllex:c=%c %c%c",c,buff[i],buff[i+1]);
DEBUGOUTL4(LEX_LOG_GROUP+255,"cllex:def_parm=%d kk_level=%d k2_level=%d k3_level=%d",def_parm,kk_level,k2_level,k3_level);
/*
if (CLcList.option & D_SCRPT_MEMORY) printf("cllex: len=%d h=%d i=%d c=%c\n",len,h,i,c);
*/
		switch(c) {
			case '#':
				if (cm_level) break;
				else if (!quote && (info=='N')) {
					sspl.sp = i;
					if ((i=cl_chk_pos(&sspl,1)) < 0) goto FEND;
					len = sspl.wdmax;
					c1 = _is_han_type(buff+i,quote,wrk,sc_code);
					if (c1=='!') {
						if ((i=_skip_line(buff,&sspl)) < 0) goto FEND;
						break;
					}
					else if (strchr(M_PRAGMA,c1)) {
						if ((i=_proc_pragma(buff,i,&sspl,c1)) < 0) {
						/*	if (i == ECL_END_OF_FILE) goto FEND;	*/
							if (i == ECL_END_OF_FILE) {
								if (!_resume_define(&sspl)) goto FEND;		/* File End */
								i = sspl.sp;
							}
							else {
								rc = i;
								goto ERR;
							}
						}
						break;
					}
				}
				wkstr[h++] = c;
				break;
			case '*':
				sspl.sp = i;
				if ((i=cl_chk_pos(&sspl,1)) < 0) goto FEND;
				len = sspl.wdmax;
				c1 = _is_han_type(buff+i,quote,wrk,sc_code);
				if (!quote && c1=='/') {
					if (cm_level > 0) {
						cm_level--;
/*
printf("cllex:i=%d len=%d buf=[%s] cm_level=%d(end)\n",i,len,buff,cm_level);
*/
						i += wrk[0];
					/*	i++;	*/
					}
					else {
						ERROROUT1("cllex: unpaired '*/' at line=%d",CLcList.line);
						return ECL_LEX;
					}
				}
				else if (!cm_level) {
					wkstr[h++] = c;
				}
				break;
			case '/':
				sspl.sp = i;
				if ((i=cl_chk_pos(&sspl,0)) < 0) goto FEND;
				len = sspl.wdmax;
				c1 = _is_han_type(buff+i,quote,wrk,sc_code);

DEBUGOUTL4(LEX_LOG_GROUP+255,"cllex:i=%d len=%d c1=%c buff=[%s]",i,len,c1,buff);
DEBUGOUTL2(LEX_LOG_GROUP+255,"cllex:moji_const=%d quote=%02x",moji_const,quote);

				if (/*h > 0 ||*/ moji_const || quote || (c1!='/' && c1!='*')) {
					if (!cm_level) {
						wkstr[h++] = c;
					}
					break;
				}
				if (c1 == '*') {
/*
printf("cllex:i=%d len=%d buf=[%s] cm_level=%d(start)\n",i,len,buff,cm_level);
*/
					cm_level++;
				/*	i++;	*/
					i += wrk[0];
					break;
				}
				if (!cm_level) {
					new_lex = 1;
					CLcList.option |= D_SCRPT_NEW_LEX;
				}
			case M_COMMENT:
			/*
				if (cm_level) break;
				else
			*/
				if (new_lex && quote) {
					wkstr[h++] = c;
					break;
				}
#if 1
				if ((i=_skip_line(buff,&sspl)) < 0) goto FEND;
#else
				line_cont = 1;
				while (line_cont) {
					if ((c1=buff[len-1])=='\n' || c1=='\r') line_cont = 0;
					rc = cl_get_str(buff);	/* ݍŝĂāA̍sǍ */
					if (rc != 0) goto FEND;	/* File End */
					len = strlen(buff);
				}
				i = 0;
				sspl.wdmax = len;
#endif
				break;
			case ')':
			case '}':
			case ']':
				if (!cm_level) {
					if (!quote) {
						rc = 0;
						if (c==')' && kk_level>0) {
							if (kk_level==def_parm) {
								kk_level--;
								if (rc=_chk_act(c)) return rc;
								wkstr[h++] = c;
								sspl.sp = i;
								if ((rc=_rep_define(&sspl,wkstr,h,c,def_parm)) < 0) goto ERR;
								i = sspl.sp;
								h = def_parm = 0;
								break;
							}
							kk_level--;
							if (!kk_level && CLcList.cmd.cid==C_TRY) {
								wkstr[h++] = c;
								rc = _kugiri(M_KUGIRI,h,wkstr,&info);
								h = 0;
								moji_const = 0;
								break;
							}
						}
						else if (c=='}' && k2_level>0 && !def_parm) k2_level--;
						else if (c==']' && k3_level>0 && !def_parm) k3_level--;
						else rc = -11;
						if (!rc && (c==')' || !def_parm)) rc = _chk_act(c);
						if (rc) {
							ERROROUT3("cllex: unpaired '%c' %s rc=%d",c,cl_lex_snln(),rc);
							return ECL_LEX;
						}
#if 0	/* add 2020.10.10 */
						else if (c=='}' || c==']') {
							sspl.sp = i;
							if ((rc=_rep_define(&sspl,wkstr,h,c,def_parm)) < 0) goto ERR;
							i = sspl.sp;
						/*	h = 0;	*/
						}
#endif
#if 1
						if (!kk_level && !k2_level && !k3_level) {
							sspl.sp = i;
							if ((i=cl_chk_pos(&sspl,1)) < 0) goto FEND;
							len = sspl.wdmax;
							c1 = buff[i];
/*
printf("cllex:i=%d c1=%c kk_level=%d k2_level=%d k3_level=%d\n",i,c1,kk_level,k2_level,k3_level);
*/
							if (c1=='T' || c1=='t' || c1=='D' || c1=='d') {
								wkstr[h++] = c;
								if (rc = _kugiri(' ',h,wkstr,&info)) return rc;
								h = 0;
								moji_const = 0;
								break;
							}
						}
#endif
					}
					wkstr[h++] = c;
				}
				break;
			case '{':
				if (!cm_level) {
					if (!quote && !def_parm) {
						k2_level++;
						if (rc=_chk_act(c)) goto ERR;
					}
					wkstr[h++] = c;
				}
				break;
#if 1
			case '\n':
			case '\r':
/*
printf("cllex:CR/LF: new_lex=%d inter_mode=%d i=%d len=%d c=%c buff=[%s]\n",new_lex,inter_mode,i,len,c,buff);
*/
				if (!new_lex) break;
				if (len==1 && inter_mode) goto FEND;
#endif
			case '\t':
			case '(':
			case '[':
			case M_SPACE:
			case M_KUGIRI:
				if (cm_level) break;
				if (!quote) {
#if 1
					rc_def = 0;
					if (def_parm) {
						wkstr[h++] = c;
						break;
					}
					else {
						sspl.sp = i - 1;
						if ((rc_def=_rep_define(&sspl,wkstr,h,c,def_parm)) < 0) {
							rc = rc_def;
							goto ERR;
						}
						else if (rc_def > 0) {
							if (rc_def == C_NO_DEF_PARM) {
								h = 0;
							}
							else if (rc_def != C_DEF_PARM) {
								i = sspl.sp;
								h = 0;
								break;
							}
						}
					}
#endif
					if (c=='(' || c=='[') {
						if (c == '(') kk_level++;
						else if (c=='[') k3_level++;
						if (rc=_chk_act(c)) goto ERR;
					}
					if (rc_def==C_DEF_PARM) {
						def_parm = kk_level;
						wkstr[h++] = c;
/*
printf("cllex:i=%d h=%d c=%c def_parm=%d\n",i,h,c,def_parm);
*/
						break;
					}
				}
/*
printf("cllex:i=%d h=%d c=%c kk_level=%d\n",i,h,c,kk_level);
*/
				if (quote || (info=='C' && (c=='[' || c=='('))) {
				/*	if (buff[i] == '\t')
						buff[i] = ' ';	*/
					wkstr[h++] = c;
				}
				else if (c==M_KUGIRI && kk_level>0) {
					wkstr[h++] = c;
				}
				else {
#if 0
					sspl.sp = i;
					if ((rc=_rep_define(&sspl,wkstr,h)) > 0) {
						i = sspl.sp;
						h = 0;
						break;
					}
					else if (rc < 0) goto ERR;
#endif
#if 1	/* 2019.10.27 */
					if (info=='C' && CLcList.cmd.cid==C_DO &&
					    !CLcList.cmd.prmnum && stricmp(wkstr,"AS")) {
						if (rc = _kugiri(';',0,wkstr,&info)) return rc;
					}
#endif
					rc = _kugiri(c,h,wkstr,&info);
					if (rc == C_PARM_CONTINUE) {
						wkstr[h++] = c;
					}
					else if (rc == C_PARM_START) {
						h = 0;
						wkstr[h++] = c;
						moji_const = 0;
					}
					else if (rc) return rc;
					else {
						h = 0;
						moji_const = 0;	/* add 2001.8.20 Koba */
					}
				}
			/*	if (c==M_KUGIRI && inter_mode) goto FEND;	*/
				break;
			case M_QUOTE1:	/* ' */
			case M_QUOTE2:	/* " */
				if (c==cM_QUOTE1) {
					if (cm_level) break;
					if (!new_lex) {
						if (h == 0) moji_const = 1;	/* add 2001.8.20 Koba */
						wkstr[h++] = c;
						break;
					}
				}
				if (cm_level) break;
				if ((c==cM_QUOTE2 && quote==cM_QUOTE2) ||
				    (c==cM_QUOTE1 && quote==cM_QUOTE1)) {
					if (c == cM_QUOTE1) {
						wkstr[h++] = c;
						if (h >= BUFLEN*8) {
							exit_flag = 1;
							break;
						}
						sspl.sp = i;
						if ((i=cl_chk_pos(&sspl,1)) < 0) goto FEND;
						len = sspl.wdmax;
						c1 = buff[i];
/*
printf("cllex:i=%d len=%d c1=%c buff=[%s]\n",i,len,c1,buff);
*/
						if (c1 == cM_QUOTE1) {
							wkstr[h++] = buff[i++];
							break;
						}
						else if (c1!='\t' && c1!=M_SPACE && c1!=M_KUGIRI) {
							moji_const = 0;
							quote = '\0';
/*
printf("cllex:moji_const=%d quote=%02x\n",moji_const,quote);
*/
							break;
						}
					}
					if (info == 'N') {	/* R}h */
						if (rc = _kugiri(c,h,wkstr,&info)) return rc;
					}
					else {
						parmlen = h;
						wkstr[h] = '\0';
						if (rc = clparmsetopt(wkstr,parmlen,1)) return rc;
					}
					h = 0;
					moji_const = 0;	/* add 2001.8.20 Koba */
					quote = '\0';
				}
				else {
					if (!quote) {
						if (h>0 && (c==cM_QUOTE2 ||
						            (c==cM_QUOTE1 && info=='N' && new_lex))) {
							wkstr[h] = '\0';
						/*	if (rc = clparmsetopt(wkstr,h,1)) return (rc);	*/
#if 1
							if (!def_parm) {
								sspl.sp = i - 1;
								if ((rc=_rep_define(&sspl,wkstr,h,c,def_parm)) < 0) goto ERR;
								else if (rc > 0) {
									if (rc_def == C_NO_DEF_PARM) {
										h = 0;
									}
									else {
										i = sspl.sp;
										h = 0;
										break;
									}
								}
							}
#endif
							if (rc = _kugiri(c,h,wkstr,&info)) return rc;
							h = 0;
							moji_const = 0;	/* add 2001.8.20 Koba */
						}
						quote = c;
						if (c == cM_QUOTE2) {
							break;
						}
					}
					wkstr[h++] = c;
				}
				break;
		/*
			case '\n':
			case '\r':
				if (inter_mode) goto FEND;
				break;
		*/
			case YEN:
#if 1
				sspl.sp = i;
				if ((i=cl_chk_pos(&sspl,2)) < 0) goto FEND;
				len = sspl.wdmax;
				if (i < len) {
					if (iskanji(buff+i)) break;
					c=buff[i];
					if (new_lex) {
						if (quote==cM_QUOTE1) {
							if (c=='\r' || c=='\n') i++;
							else wkstr[h++] = YEN;
						}
						else {
							if (c=='\r' || c=='\n') i++;
							else {
								if (!cm_level) {
									wkstr[h++] = c;
								}
								i++;
							}
						}
					}
					else {
						if (c!='\t' && c!='\n' && c!=M_SPACE) {
							if (!cm_level) {
								wkstr[h++] = c;
							}
							i++;
						}
					}
				}
#else
				if (new_lex && quote==cM_QUOTE1) {
					wkstr[h++] = c;
				}
				else {
					sspl.sp = i;
					i = cl_chk_pos(&sspl,2);
					len = sspl.wdmax;
					if (i < len) {
						if (iskanji(buff+i)) break;
						c=buff[i];
						if (c!='\t' && c!='\n' && c!=M_SPACE) {
							if (!cm_level) {
								wkstr[h++] = c;
							}
							i++;
						}
					}
				}
#endif
				break;
			default:
				if (!cm_level) {
					wkstr[h++] = c;
				}
				break;
		}
	}
	ERROROUT2("cllex:String too long.[%s] %s", wkstr,cl_lex_snln());
	return ECL_LEX;
FEND:
	p = cl_lex_snln();
	if (kk_level || k2_level || k3_level) {
					/* cllex: JbR('(')Ă܂(%s)Bkk_level=%d */
		if (kk_level) ERROROUT2(FORMAT(31),p,kk_level);
					/* cllex: JbR('{')Ă܂(%s)Bk2_level=%d */
		if (k2_level) ERROROUT2(FORMAT(38),p,k2_level);
					/* cllex: JbR('[')Ă܂(%s)Bk3_level=% */
		if (k3_level) ERROROUT2(FORMAT(39),p,k3_level);
		return ECL_LEX;
	}
	else if (cm_level) {
		/* cllex: RgĂ܂(%s)Bcm_level=%d */
		ERROROUT2(FORMAT(32),p,cm_level);
		return ECL_LEX;
	}
	else if (quote) {
		/* "cllex: p(%c)Ă܂(%s)B */
		ERROROUT2(FORMAT(33),quote,p);
		return ECL_LEX;
	}
	else if (info=='C' || h>0) {
		if (h>0) {
			wkstr[h] = '\0';
			clparmsetopt(wkstr,h,1);
		}
		ERROROUT1(FORMAT(34),p);	/* cllex: IĂ܂(%s)B */
		if (!cl_get_cmd_line(&CLcList.cmd,&parm)) ERROROUT1(" ---> [%s]",parm);
		else ERROROUT1(FORMAT(35),wkstr);	/* cllex: [%s]͗Lȕł͂܂B */
		return ECL_LEX;
	}
FEND2:
	cl_cmd_init(&CLcList.cmd);
	clparmclr();
	CLcList.cmd.cid = C_FEND;	/* t@CI */
	CLcList.cmd.type = 0;
#if 0
	if (rc = clparmset2()) return rc;
#endif
	rc = cl_syn_main();
/*
printf("cllex: cl_syn_main rc=%d\n",rc);
*/
	cl_cmd_init(&CLcList.cmd);
	clparmclr();
/*	memset(&CLcList.cmd,0,sizeof(cmdInfo));	*/
	CLSTCB.nestLev1 = NULL;
	CLSTCB.nestLev2 = NULL;
	info = 'N';
	return rc;
ERR:
	ERROROUT2("cllex:rc=%d %s",rc,cl_lex_snln());
	wkstr[h] = '\0';
	if (cl_get_cmd_line(&CLcList.cmd,&parm)) parm = "";
	ERROROUT2(" ---> [%s %s]",parm,wkstr);
	return rc;
}

/************************************/
/* if level ̃X^bNɂǗ	*/
/************************************/
#define IF_LEVEL_EXT	16
static int if_level_max=0;
static int if_level=0;
static char *if_stack=NULL;

/************************************/
/* _set_if_level					*/
/************************************/
static int _set_if_level(up,thenl)
int up,thenl;
{
	if (up >= 0) {
		if (up) if_level++;
		if (if_level >= if_level_max) {
			if_level_max += IF_LEVEL_EXT;
			if_stack = MRealloc(if_stack,if_level_max);
			if (!if_stack) return -1;
		}
		if_stack[if_level] = thenl;
	}
	else if (up < 0) {
		if (if_level > 0) if_level--;
		if (if_level > 0) thenl = if_stack[if_level];
		else thenl = 0;
	}
/*
printf("_set_if_level: up=%d thenl=%d if_level=%d\n",up,thenl,if_level);
*/
	return thenl;
}

/************************************/
/* _get_if_level					*/
/************************************/
static int _get_if_level()
{
	int thenl;

	if (if_stack && if_level>0) thenl = if_stack[if_level];
	else thenl = 0;
/*
printf("_get_if_level: thenl=%d if_level=%d\n",thenl,if_level);
*/
	return thenl;
}

/************************************/
/* _insert_ENDIF					*/
/************************************/
static int _insert_ENDIF(n)
int n;
{
	int rc=0;
	cmdTable *pcmd;
	condList TmpcList;
	parmList *tmplp;
/*
printf("cllex:_insert_ENDIF: n=%d\n",n);
*/
	if (n > 0) {
		TmpcList = CLcList;
		tmplp = CLcList.cmd.prmp[0];
		pcmd = cl_cmd_chk("ENDIF");
		cl_cmd_init(&CLcList.cmd);
		CLcList.cmd.cid  = pcmd->cmdid;
		CLcList.cmd.type = pcmd->type;
		CLcList.cmd.rc   = CLcList.line;
		while (n-- > 0) {
/*
printf("cllex:_insert_ENDIF: comstr=[ENDIF] at line=%d\n",CLcList.line);
*/
			CLcList.cmd.prmnum = 0;
			if (rc = clparmset("",0)) break;
			CLcList.cmd.prmnum--;
			if (rc = clparmset2()) break;
			if (rc = cl_syn_main()) break;
		}
		CLcList = TmpcList;
		CLcList.cmd.prmp[0] = tmplp;
	}
	return rc;
}

/************************************/
/* _kugiri							*/
/************************************/
static int _kugiri(kc,h,wkstr,pinfo)
char kc,*wkstr,*pinfo;
int  h;
{
	int rc,parmlen,cnum,cid,no_kugiri,n,i,thenl,elsel,cmd_count,scno,pos;
	cmdTable *pcmd;
	char *p,wrk[2];

	parmlen = h;
	wkstr[parmlen] = '\0';

DEBUGOUTL5(LEX_LOG_GROUP+124,"_kugiri: kc=%c h=%d wkstr=[%s] info=%c cid=%08x",kc,h,wkstr,*pinfo,CLcList.cmd.cid);

/*
printf("_kugiri: kc=%c h=%d wkstr=[%s] info=%c cid=%08x\n",kc,h,wkstr,*pinfo,CLcList.cmd.cid);
*/
/*
printf("_kugiri: cid=%08x thenl_level=%d\n",cid,thenl_level);
*/
	if (*pinfo == 'N') CLcList.cmd.cid = C_UNKNOWN;
	thenl = 0;
	elsel = 0;
#if 1
	if (parmlen>0 || (!parmlen && (kc=='(' || kc=='['))) {
#else
	if (parmlen>0 || (!parmlen && kc=='(')) {
#endif
		if (*pinfo == 'N'){	/* R}h */
			cl_cmd_init(&CLcList.cmd);
			pcmd = cl_cmd_chk(wkstr);
			if (pcmd->cmdid == C_UNKNOWN) {
				strcpy(comstr,"LET");
				pcmd = cl_cmd_chk(comstr);
				CLcList.cmd.cid = cid = pcmd->cmdid;
				CLcList.cmd.type = pcmd->type;
				CLcList.cmd.rc  =  CLcList.line;
				*pinfo = 'C';
				if (kc=='[' || kc=='(') return C_PARM_CONTINUE;
				if (rc=clparmsetopt(wkstr, parmlen,1)) return rc;
			}
			else {
				CLcList.cmd.cid = cid = pcmd->cmdid;
				CLcList.cmd.type = pcmd->type;
				CLcList.cmd.rc  =  CLcList.line;/*add 95.1.4 Koba*/
				*pinfo = 'C';
				strcpy(comstr,wkstr);
				if (kc == '(') return C_PARM_START;
				if ((
#if 0	/* 2019.10.23 */
				     cid==C_DO ||
#endif
					 cid==C_ELSE || cid==C_DEFAULT || cid==C_ELSEL ||
#if 0	/* 2017.05.20 */
				     cid==C_TRY ||
#endif
				     cid==C_FINALLY) &&
				    (kc==' ' || kc=='\t' || kc=='\n')) {
					kc = M_KUGIRI;
					if (cid == C_ELSEL) {
						CLcList.cmd.cid = cid = C_ELSE;
						elsel = 1;
					}
				}
				else if (cid==C_LABEL && CLcList.cmd.type==9) {
					kc = M_KUGIRI;
					if (rc=clparmsetopt(wkstr,parmlen-1,1)) return rc;
				}
			}
		}
		else {	/* p[^ */
			no_kugiri = 1;
			cid = CLcList.cmd.cid;
			if (cid==C_IF || cid==C_ELSEIF) {
				if (!stricmp(wkstr,"THEN")) {
					no_kugiri = 0;
					kc = M_KUGIRI;
				}
				else if (!stricmp(wkstr,"THENL")) {
					no_kugiri = 0;
					kc = M_KUGIRI;
					thenl = 1;
				}
			}
			else if ((cid==C_LOOP || cid==C_FOR || cid==C_WHILE || cid==C_UNTIL) &&
			     !stricmp(wkstr,"DO")) {
				no_kugiri = 0;
				kc = M_KUGIRI;
				CLcList.cmd.sub_cid = C_LOOP_DO;
			}
			else if (cid == C_TRY) {
				pos= akxnskipin(wkstr,strlen(wkstr)," \t");
				if (!CLcList.cmd.prmnum && wkstr[pos]!='(') {
					if ((rc=_kugiri(M_KUGIRI,0,wrk,pinfo)) < 0) return rc;
					return _kugiri(kc,h,wkstr,pinfo);
				}
			}
			if (no_kugiri) {
				if (rc=clparmsetopt(wkstr,parmlen,1)) return rc;
			}
		}
	}
	if (kc==M_KUGIRI && CLcList.cmd.cid!=C_UNKNOWN) {
/*
printf("_kugiri: comstr=[%s] at line=%d\n",comstr,CLcList.line);
*/
		if (rc = clparmset("",0)) return rc;	/* [NGAŌɕt */
		if (rc = clparmset("",0)) return rc;	/* 2020.10.29 add */
		CLcList.cmd.prmnum -= 2;				/* p[^ɏL͓Ȃ */
#if 1
		if (rc = clparmset2()) return rc;
#endif
		cid = CLcList.cmd.cid;
#if 1
/*
printf("_kugiri: thenl_level=%d else_level=%d cmd_count=%d\n",
thenl_level,else_level,cmd_count);
*/
		if ((cmd_count=_get_if_level()) > 0) {
			if (cid==C_ELSE || cid==C_ELSEIF ||
			    (cid==C_END && !stricmp(wkstr,"IF")) || cmd_count>1) {
				while (_get_if_level() > 0) {
					if (rc=_insert_ENDIF(1)) return rc;
					_set_if_level(-1,0);
				}
				elsel = 0;
			}
		}
#endif
		if (rc = cl_syn_main()) {	/* ͖؍쐬 */
			return rc;
		}
#if 1
		scno = CLcList.cmd.sub_cid;
		if ((cid==C_LET || cid==C_DEFINE) && (scno==CS_OPTIONS || scno==CS_OPTION)) {
			cM_QUOTE1 = pGlobTable->Quot[0];
			cM_QUOTE2 = pGlobTable->Quot[1];
		}
#endif
#if 1
		/* "end if" ́Acl_syn_main()̒C_ENDIFɕϊ̂cidĐݒ肷 */
		cid = CLcList.cmd.cid;
/*
printf("_kugiri: comstr=[%s] at line=%d thenl=%d elsel=%d thenl_level=%d\n",
comstr,CLcList.line,thenl,elsel,_get_if_level());
*/
		if (cid == C_IF) {
			if (_get_if_level() > 0) _set_if_level(0,2);
			_set_if_level(1,thenl);
		}
		else if (cid == C_ELSEIF) _set_if_level(0,thenl);
		else if (cid == C_ELSE)   _set_if_level(0,elsel);
		else if (cid == C_ENDIF)  _set_if_level(-1,0);
		else {
			while (_get_if_level() > 0) {
				if (rc = _insert_ENDIF(1)) return rc;
				_set_if_level(-1,0);
			}
		}
#endif
		*pinfo = 'N';
		cl_cmd_init(&CLcList.cmd);
		clparmclr();
	}
	return 0;
}

/************************************/
/* _nest_up							*/
/************************************/
static int _nest_up(ifnest_cnt)
int ifnest_cnt;
{
	ifnest_cnt++;
	if (ifnest_cnt>=MAXIFNEST) {
		ERROROUT("if nest over!!");
		return -1;
	}
	return ifnest_cnt;
}

/************************************/
/* _check_defined					*/
/************************************/
static int _check_defined(word,pp)
char *word,**pp;
{
	int ix;

	ix = 0;
	if (       sqp_lex_def)  ix = akxs_xseqs2(sqp_lex_def,'R',word,pp);
	if (!ix && xhp_main_def) ix = akxs_xhash2(xhp_main_def,'R',word,pp);
	if (!ix && xhp_lex_def)  ix = akxs_xhash2(xhp_lex_def,'R',word,pp);
	return ix;
}

/************************************/
/* _PragmaStackInit					*/
/************************************/
static int _PragmaStackInit()
{
	SSPL_S *pspSTK;
	tdtInfoParm *pInfoParm;
	condList *pCLcList;
	tdtPragmaStack *pPrag;
	char *p;

	while (iListStack > 0) {
		pPrag = &tPragmaStack[iListStack];
		pCLcList = &pPrag->pra_cList;
		if (pCLcList->option & D_SCRPT_MEMORY) {
			pInfoParm = (tdtInfoParm *)pCLcList->fp;
			Free(pInfoParm->pi_data);
			Free(pInfoParm->pi_paux);
			Free(pInfoParm);
		}
		iListStack--;
		pPrag = &tPragmaStack[iListStack];
		if (p=pPrag->pra_defkey) Free(p);
		pspSTK = &pPrag->pra_sspl;
		if (p=pspSTK->wd) Free(p);
	}
#if 1
	p = akxt_get_last_name("\\/",CLcList.fullname);
#else
	if (!(p = cl_set_script_name_extension(CLcList.fname,strlen(CLcList.fname)))) return -1;
#endif
/*
printf("_PragmaStackInit: p=[%s]\n",p);
*/
	pPrag = &tPragmaStack[0];
	pPrag->pra_opt = 1;
	pPrag->pra_defkey = Strdup(p);
	pspSTK = &pPrag->pra_sspl;
	pspSTK->wd = NULL;
	iListStack0=1;
	iListStack=1;
	if (xhp_lex_def) {
		akxs_xhash_free(xhp_lex_def);
		xhp_lex_def = NULL;
	}
	if (sqp_lex_def) {
		akxs_xseqs_free(sqp_lex_def);
		sqp_lex_def = NULL;
	}
	return 0;
}

/************************************/
/* _proc_pragma						*/
/************************************/
static int _proc_pragma(buf,pos,psspl,optc)
char *buf;
int pos;
SSPL_S *psspl;
char optc;
{
	static char *_fn_="_proc_pragma";
	static char *command[]=
		{"define","undef","ifdef","ifndef","if","elif","else","endif","elifdef","elifndef","include",NULL};
	SSP_S ssp;
	char *p,word[BUFLEN*8],cmd,c,*key;
	int len,i,ix,icmd,iTrue,tr,ifflg;
	int op,stack[2],istack,v,rc;

	if (!buf) {
	/*
		if (xhp_lex_def) akxs_xhash_free(xhp_lex_def);
		xhp_lex_def = NULL;
	*/
		ifnest_cnt=0;
		ifnest[0]=1;
		iftrue[0]=0;
		return _PragmaStackInit();
	}
	CLcList.cmd.cid = C_PRAGMA;
	ssp.sp = pos + 1;
	ssp.wd = word;
	if ((len=akxtgwsp(buf,&ssp)) > 0) {

DEBUGOUTL1(LEX_LOG_GROUP+122,"_proc_pragma: word=[%s]",word);

		clparmclr();
		clparmset(buf+pos+1,psspl->wdmax-(pos+1));
		icmd = i = 0;
		while (p=command[i++]) {
			if (!strcmp(word,p)) break;
		}
		if (p) {
			icmd=i;
		}
		else {
			ERROROUT1("_proc_pragma: invalid command(%s).",word);
			return -1;
		}
		CLcList.cmd.sub_cid = i;
/*
printf("_proc_pragma: icmd=%d ifnest_cnt=%d ifnest=%d\n",icmd,ifnest_cnt,ifnest[ifnest_cnt]);
*/
		if (icmd==1 || icmd==2) {			/* define, undef */
/*
printf("_proc_pragma: icmd=%d optc=%c\n",icmd,optc);
*/
			if (optc == DEF_OPTC_ICASE) {
				if (!sqp_lex_def) {
					if (!(sqp_lex_def=akxs_xseqs_new2(0,DEFICASEMAX,0))) return -1;
					sqp_lex_def->xha_prereg = AKX_ARGV_USE_ICMP;
				}
			}
			else {
				if (!xhp_lex_def) {
					if (!(xhp_lex_def=akxs_xhash_new2(0,10,7,0))) return -1;
				}
			}
			if ((len=akxtgwse(buf,&ssp," \t(",0x01)) > 0) {
DEBUGOUTL2(LEX_LOG_GROUP+122,"_proc_pragma: icmd=%d word=[%s]",icmd,word);
				if ((i=akxnskipto(word,len," \t'\"()")) < len) {
					/* %s: L[[%s](pos=%d)ɎgpłȂ܂B */
					ERROROUT3(FORMAT(52),_fn_,word,i+1);
					return -1;
				}
				if (icmd==1) {
					if (optc == DEF_OPTC_ICASE)
						ix = akxs_xseqs(sqp_lex_def,'R',word);
					else
						ix = akxs_xhash(xhp_lex_def,'R',word);
					if (ix < 0) return ix;
					else if (ix > 0) {
						/* %s: L[[%s]`ς݂łB */
						ERROROUT2(FORMAT(53),_fn_,word);
						return -1;
					}
					cmd = 'S';
					ssp.wd += len + 1;
					i = _get_def_cont(buf,ssp.sp,psspl,ssp.wd,sizeof(word)-(len+1));
/*
printf("_proc_pragma: ssp.wd=[%s]\n",ssp.wd);
*/
					if (i < 0) return i;
				}
				else cmd = 'D';
				if (optc == DEF_OPTC_ICASE)
					ix = akxs_xseqs2(sqp_lex_def,cmd,word,ssp.wd);
				else
					ix = akxs_xhash2(xhp_lex_def,cmd,word,ssp.wd);
				if (ix < 0) return ix;
				ssp.wd = word;
			}
		}
		else if (icmd == 11) {	/* include */
			if ((len=akxtgwse(buf,&ssp," \t",0x03)) <= 0) {
				/* %s: t@Cw肳Ă܂B */
				ERROROUT1(FORMAT(54),_fn_);
				return -1;
			}
			return _include_define(psspl,word);
		}
		else if (icmd > 0) {
			if (icmd>=6 && ifnest_cnt<=0) {
				/* %s: if,ifdef,ifndefȂ̂ɁA[%s]w肳܂B */
				ERROROUT2(FORMAT(54),_fn_,word);
				return -1;
			}
			tr = iTrue = iftrue[ifnest_cnt];
/*
printf("_proc_pragma: iTrue=%d icmd=%d\n",iTrue,icmd);
*/
			if (icmd==7) {		/* else */
				if (iTrue) v = 0;
				else v = 1;
				ifnest[ifnest_cnt] = v;
				iftrue[ifnest_cnt] = 1;
/*
printf("_proc_pragma: else ifnest_cnt=%d ifnest=%d\n",ifnest_cnt,ifnest[ifnest_cnt]);
*/
			}
			else if (icmd==8) {	/* endif */
				ifnest_cnt--;
			}
			else {
		/*	else if ((len=akxtgwse(buf,&ssp," \t",0x03)) > 0) {	*/
/*
printf("_proc_pragma: word=[%s]\n",word);
*/
				if (icmd==3 || icmd==4 ||		/* ifdef, ifndef */
				    icmd==9 || icmd==10) {		/* elifdef, elifndef */
					if ((len=akxtgwse(buf,&ssp," \t(",0x01)) > 0) {
DEBUGOUTL2(LEX_LOG_GROUP+122,"_proc_pragma: icmd=%d word=[%s]\n",icmd,word);
						if (icmd==3 || icmd==4) {
							if ((ifnest_cnt=_nest_up(ifnest_cnt)) < 0) return ifnest_cnt;
						}
						if ((icmd==9 || icmd==10) && iTrue) ix = 0;
						else {
							ix = _check_defined(word,NULL);
							if (ix < 0) return ix;
							if (icmd==4 || icmd==10) {
								if (ix) ix = 0;
								else ix = 1;
							}
							tr = ix;
						}
						ifnest[ifnest_cnt] = ix;
						iftrue[ifnest_cnt] = tr;
/*
printf("_proc_pragma: icmd=%d ifnest_cnt=%d ifnest=%d iftrue=%d\n",icmd,ifnest_cnt,v,tr);
*/
					}
				}
				else if (icmd==5 || icmd==6) {	/* if, elif */
					if ((len=akxtgwsp(buf,&ssp)) > 0) {
DEBUGOUTL2(LEX_LOG_GROUP+122,"_proc_pragma: icmd=%d word=[%s]\n",icmd,word);
						if (icmd==5) {
							if ((ifnest_cnt=_nest_up(ifnest_cnt)) < 0) return ifnest_cnt;
						}
						if (icmd==6 && iTrue) v = 0;
						else {
							if (((c=*word)>='0' && c<='9') || c=='+' || c=='-') {
							/*
								if ((rc=akxcecvn(NULL,word,len,&v)) < 0) return rc;
		 						tr = v;
							*/
		 						tr = v = atoi(word);
							}
							else {
								tr = v = istack = 0;
								while (len>0) {
									if (!strcmp(word,"defined")) {
										len=akxtgwsp(buf,&ssp);	/* '(' */
										len=akxtgwsp(buf,&ssp);

DEBUGOUTL1(LEX_LOG_GROUP+122,"_proc_pragma:if: word=[%s]\n",word);

										ix=_check_defined(word,NULL);
										if (ix>0) v = 1;
										else v = 0;
										tr = v;
										len = akxtgwsp(buf,&ssp);	/* ')' */
										stack[istack++] = v;
										if (istack == 2) {
											if (op) v = stack[0] && stack[1];
											else    v = stack[0] || stack[1];
											ifnest[ifnest_cnt] = v;

DEBUGOUTL3(LEX_LOG_GROUP+122,"if: stack[0]=%d stack[1]=%d v=%d",stack[0],stack[1],v);

											istack = 0;
										}
									}
									else {
										/* %s: if syntax error!! defined only(word=[%s]). */
										ERROROUT2(FORMAT(551),_fn_,word);
										return -1;
									}
									if ((len=akxtgwsp(buf,&ssp)) > 0) {
										if (!strcmp(word,"||")) op = 0;
										else if (!strcmp(word,"&&")) op = 1;
										else {
											/* %s: if syntax error!! op=[%s] */
											ERROROUT2(FORMAT(552),_fn_,word);
											return -1;
										}
/*
printf("if: op=%s %d\n",w,op);
*/
										len = akxtgwsp(buf,&ssp);
									}
								}
							}
						}
						ifnest[ifnest_cnt] = v;
						iftrue[ifnest_cnt] = tr;
/*
printf("_proc_pragma: icmd=%d ifnest_cnt=%d ifnest=%d iftrue=%d\n",icmd,ifnest_cnt,v,tr);
*/
					}
				}
			}
			ifflg = 1;
			for (i=1;i<=ifnest_cnt;i++) {
				if (!ifnest[i]) {
					ifflg = 0;
					break;
				}
			}
/*
printf("_proc_pragma: icmd=%d ifflg=%d\n",icmd,ifflg);
*/
			i = _skip_line(buf,psspl);
			if (!ifflg) {
				while (i>=0) {
					if (buf[0]=='#' && strchr(M_PRAGMA,buf[1])) break;
					i = _skip_line(buf,psspl);
				}
			}
			return i;
		}
	}
	i = _skip_line(buf,psspl);
	return i;
}

/************************************/
/* _rep_define						*/
/************************************/
static int _rep_define(psspl,s0,n,kc,def_parm)
SSPL_S *psspl;
char *s0;
int n;
char kc;
int def_parm;
{
	static char *_fn_="_rep_define";
	static MCAT mcat={'M','C',256,0,0,0,NULL,0};
	int i,ix,rc,dlen,ret=0;
	char *s,*p,*buff;
	condList *pclSTK;
	SSPL_S *pspSTK;
	tdtInfoParm *pInfoParm;
	SSP_S *ssp;
	tdtPragmaStack *pPrag;

	s0[n] = '\0';

DEBUGOUTL4(LEX_LOG_GROUP+106,"_rep_define: def_parm=%d n=%d s0=[%s] kc=[%c]",def_parm,n,s0,kc);

	if (n>0 && (sqp_lex_def || xhp_main_def || xhp_lex_def)) {
		s = s0;
		if (def_parm) {
			if (i=akxs_in_mem_opt(s,strlen(s),"(",1,0)) {
				kc = '(';
				s = strmem(s,i-1);
			}
		}
/*
printf("_rep_define: s=[%s]\n",s);
*/
		ix = _check_defined(s,&p);
		if (ix > 0) {
/*
printf("_rep_define: iListStack=%d ix=%d s=[%s] p=[%s]\n",iListStack,ix,s,p);
*/
			pPrag = &tPragmaStack[0];
			for (i=0;i<iListStack;i++,pPrag++) {
/*
printf("_rep_define: defStack[%d]=[%s]\n",i,pPrag->pra_defkey);
*/
				if (!pPrag->pra_opt && !strcmp(pPrag->pra_defkey,s)) {
					/* %s: define word[%s] is loop!! */
					ERROROUT2(FORMAT(553),_fn_,s);
					return -1;
				}
			}
			if ((dlen=strlen(p)) <= 0) return C_NO_DEF_PARM;
			if (iListStack < CLISTSTACKMAX) {
				if (def_parm) {
					if ((rc=_rep_def_parm(&mcat,s0,p)) < 0) return rc;
					p = mcat.mc_bufp;
					dlen = mcat.mc_ipos;
				}
				else if (*p=='(') {
					if (kc=='(') return C_DEF_PARM;
					else {
						/* %s: p[^KvłB */
						ERROROUT1(FORMAT(44),_fn_);
						return -1;
					}
				}
				pPrag = &tPragmaStack[iListStack];
				pPrag->pra_opt = 0;
				pPrag->pra_defkey = Strdup(s);
				memcpy(pclSTK=&pPrag->pra_cList,&CLcList,sizeof(condList));
				memcpy(pspSTK=&pPrag->pra_sspl,psspl,sizeof(SSPL_S));
				pspSTK->wd = Memdup(buff=psspl->wd,psspl->wdmax);
				ssp = (SSP_S *)Malloc(sizeof(SSP_S));
				pInfoParm = (tdtInfoParm *)Malloc(sizeof(tdtInfoParm));
				ssp->sp = 0;
				pInfoParm->pi_paux = (char *)ssp;
				pInfoParm->pi_dlen = dlen;
				pInfoParm->pi_data = Strdup(p);
				pInfoParm->pi_scale = D_DATA_MALLOC;
				CLcList.fp = (FILE *)pInfoParm;
				CLcList.line = 0;
				CLcList.option |= D_SCRPT_MEMORY;

DEBUGOUTL3(LEX_LOG_GROUP+122,"_rep_define: iListStack=%d key=[%s] parm=[%s]",iListStack,s,p);

				iListStack++;
				memcpy(&tPragmaStack[iListStack].pra_cList,&CLcList,sizeof(condList));
				if (cl_get_str(buff)) {
					_resume_define(psspl);
					ret = C_NO_DEF_PARM;
				}
				else {
					psspl->sp = 0;
					psspl->wdmax = strlen(buff);
					psspl->attr[3] = 0;
					ret = 1;
				}
			}
			else {
				/* %s: define stack over(%d)!! */
				ERROROUT2(FORMAT(554),_fn_,iListStack);
				ret = -1;
			}
		}
		else if (ix < 0) ret = ix;
	}
	return ret;
}

/************************************/
/* _resume_define					*/
/************************************/
static int _resume_define(psspl)
SSPL_S *psspl;
{
	int ix,rc,ret=0;
	char *p;
	condList *pclSTK;
	SSPL_S *pspSTK;
	tdtInfoParm *pInfoParm;
	SSP_S *ssp;
	condList *pCLcList;
	tdtPragmaStack *pPrag;
/*
printf("_resume_define:1: iListStack=%d psspl->sp=%d psspl->wd=[%s]\n",
iListStack,psspl->sp,psspl->wd);
*/
	if (iListStack > iListStack0) {
		pPrag = &tPragmaStack[iListStack];
		pCLcList = &pPrag->pra_cList;
		if (pCLcList->option & D_SCRPT_MEMORY) {
			pInfoParm = (tdtInfoParm *)pCLcList->fp;
			Free(pInfoParm->pi_data);
			Free(pInfoParm->pi_paux);
			Free(pInfoParm);
		}
	/*
		else {
			Free(pCLcList->fullname);
		}
	*/
		iListStack--;
		pPrag = &tPragmaStack[iListStack];
		if (p=pPrag->pra_defkey) Free(p);
		pPrag->pra_defkey = NULL;
		pCLcList = &pPrag->pra_cList;
		CLcList.fp = pCLcList->fp;
		CLcList.line = pCLcList->line;
		CLcList.option = pCLcList->option;
		CLcList.fullname = pCLcList->fullname;
		pspSTK = &pPrag->pra_sspl;
		p = psspl->wd;
		memcpy(psspl,pspSTK,sizeof(SSPL_S));
		psspl->wd = p;
		memcpy(p,pspSTK->wd,psspl->wdmax);
		Free(pspSTK->wd);
		ret = 1;

DEBUGOUTL3(LEX_LOG_GROUP+122,"_resume_define:2: iListStack=%d psspl->sp=%d psspl->wd=[%s]",
iListStack,psspl->sp,psspl->wd);

	}
	return ret;
}

/************************************/
/* _rep_def_parm					*/
/************************************/
int _rep_def_parm(mcat,s,parm)
MCAT *mcat;
char *s,*parm;
{
	int is,ie,n,np,i,len,parmlen,attr0,opt;
	char *argv[21],buf[128];
	char *argvp[21],bufp[256],word[256],*p;
	SSPL_S sspl;

	is = akxs_in_str_opt(s,"(",0);
	ie = akxs_in_str_opt(s,")",0);
	n = akxtgetargvn2(s+is,ie-is-1,argv,20,buf,sizeof(buf),AKX_ARGV_DELM_COM|AKX_ARGV_NOT_CUT_QUOT);
	parmlen = strlen(parm);
	is = akxs_in_str_opt(parm,"(",0);
	ie = akxs_in_str_opt(parm,")",0);
	np = akxtgetargvn2(parm+is,ie-is-1,argvp,20,bufp,sizeof(bufp),AKX_ARGV_DELM_COM);
	if (n != np) {
		/* _rep_def_parm: ̐(%d)Ɖ̐(%d)Ă܂B */
		ERROROUT2(FORMAT(555),n,np);
		return -1;
	}
	sspl.sp = ie + 1;
	sspl.wd = word;
	sspl.wdmax = sizeof(word);
	mcat->mc_ipos = 0;
	attr0 = 100;
	if (pGlobTable->options[8] & 0x04) opt = 0x101;
	else opt = 0x201;
	for (;;) {
		if ((len=akxtgwnsl(parm,parmlen,&sspl,NULL,opt)) < 0) break;
		if (attr0<10 && sspl.attr[0]<10) akxtmcats(mcat," ");
		for (i=0;i<np;i++) {
			if (!strcmp(sspl.wd,argvp[i])) {
				break;
			}
		}
		if (i < np) p = argv[i];
		else p = sspl.wd;
		akxtmcats(mcat,p);
		attr0 = sspl.attr[0];
	}
	return 0;
}

/************************************/
/* _include_define					*/
/************************************/
static int _include_define(psspl,name)
SSPL_S *psspl;
char *name;
{
	static char *_fn_="_include_define";
	static char *fmt="***** Include file ( %s ) *****";
	char *scrname,dir[256];
	int i,ix,rc,dlen,ret=0;
	char *buff;
	condList *pclSTK;
	SSPL_S *pspSTK;
	tdtPragmaStack *pPrag;
	FILE *fp;

	if (!(scrname = cl_set_script_name_extension(name,strlen(name)))) return -1;

	pPrag = &tPragmaStack[0];
	for (i=0;i<iListStack;i++,pPrag++) {
/*
printf("_include_define: defStack[%d]=[%s]\n",i,pPrag->pra_defkey);
*/
		if (pPrag->pra_opt && !strcmp(pPrag->pra_defkey,scrname)) {
			/* %s: include file[%s] is loop!! */
			ERROROUT2(FORMAT(556),_fn_,scrname);
			return -1;
		}
	}
	if (iListStack >= CLISTSTACKMAX) {
		/* %s: define stack over(%d)!! */
		ERROROUT2(FORMAT(557),_fn_,iListStack);
		return -1;
	}
/*	PRINTOUT1(fmt,scrname);
	DEBUGOUTL1(1,fmt,scrname);	*/
	PRDBGOUTL1(1,fmt,scrname);

	fp = cl_lex_file_open(scrname,dir,_fn_);
	if (!fp) return ECL_SCR_NOTFOUND;	/* t@CI[vG[ */
	if ((i=_skip_line(psspl->wd,psspl)) >= 0) psspl->sp = 0;
	pPrag = &tPragmaStack[iListStack];
	pPrag->pra_opt = 1;
	pPrag->pra_defkey = Strdup(scrname);
	memcpy(pclSTK=&pPrag->pra_cList,&CLcList,sizeof(condList));
	memcpy(pspSTK=&pPrag->pra_sspl,psspl,sizeof(SSPL_S));
	pspSTK->wd = Memdup(buff=psspl->wd,psspl->wdmax);
	CLcList.fp = fp;
	CLcList.line = 0;
	CLcList.option = 0;
	if (!(CLcList.fullname = cl_const_ct_malloc(CLcList.ConstCt,strlen(dir)+1))) {
		Free(pPrag->pra_defkey);
		pPrag->pra_defkey = NULL;
		Free(pspSTK->wd);
		pspSTK->wd = NULL;
		return ECL_MALLOC_ERROR;
	}
	strcpy(CLcList.fullname,dir);
/*
printf("_include_define: iListStack=%d scrname=[%s] dir=[%s]\n",iListStack,scrname,dir);
*/
	CLcList.cmd.parl[1].par = CLcList.fullname;
	iListStack++;
	memcpy(&tPragmaStack[iListStack].pra_cList,&CLcList,sizeof(condList));
	if (cl_get_str(buff)) {
		_resume_define(psspl);
	}
	else {
		psspl->sp = 0;
		psspl->wdmax = strlen(buff);
		psspl->attr[3] = 0;
DEBUGOUTL3(LEX_LOG_GROUP+122,"_include_define: iListStack=%d scrname=[%s] buf=[%s]",
iListStack,scrname,buff);
	}
	return 0;
}
